﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Devices.Geolocation;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Maps;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Imaging;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=391641

namespace TapDemo
{
  /// <summary>
  /// An empty page that can be used on its own or navigated to within a Frame.
  /// </summary>
  public sealed partial class MainPage : Page
  {
    public MainPage()
    {
      this.InitializeComponent();

      this.NavigationCacheMode = NavigationCacheMode.Required;
    }

    /// <summary>
    /// Invoked when this page is about to be displayed in a Frame.
    /// </summary>
    /// <param name="e">Event data that describes how this page was reached.
    /// This parameter is typically used to configure the page.</param>
    protected override void OnNavigatedTo(NavigationEventArgs e)
    {
      MyMap.Center = new Geopoint(new BasicGeoposition { Latitude = 52.155915, Longitude = 5.390376 });
      MyMap.ZoomLevel = 18;

      const double d = 0.0005;

      var p1 = new BasicGeoposition
      {
        Latitude = MyMap.Center.Position.Latitude - d,
        Longitude = MyMap.Center.Position.Longitude
      };

      var p2 = new BasicGeoposition
      {
        Latitude = MyMap.Center.Position.Latitude + d,
        Longitude = MyMap.Center.Position.Longitude
      };

      var p3 = new BasicGeoposition
      {
        Latitude = MyMap.Center.Position.Latitude,
        Longitude = MyMap.Center.Position.Longitude - d
      };

      var p4 = new BasicGeoposition
      {
        Latitude = MyMap.Center.Position.Latitude,
        Longitude = MyMap.Center.Position.Longitude + d
      };

      var p5 = new Geopoint(new BasicGeoposition
      {
        Latitude = MyMap.Center.Position.Latitude ,
        Longitude = MyMap.Center.Position.Longitude 
      });

      var line1 = new MapPolyline
      {
        StrokeThickness = 11,
        StrokeColor = Colors.Green,
        Path = new Geopath(new List<BasicGeoposition> { p1, p2 })
      };

      var line2 = new MapPolyline
      {
        StrokeThickness = 11,
        StrokeColor = Colors.Green,
        Path = new Geopath(new List<BasicGeoposition> { p3, p4 })
      };

      MyMap.MapElements.Add(line1);
      MyMap.MapElements.Add(line2);

      var childObj = new Image { Source = new BitmapImage(new Uri("ms-appx:///Assets/wplogo.png")) };
      MapControl.SetNormalizedAnchorPoint(childObj, new Point(0.5, 0.5));
      MapControl.SetLocation(childObj, p5);
      MyMap.Children.Add(childObj);
      childObj.Tapped += ChildObj_Tapped;
    }

    void ChildObj_Tapped(object sender, TappedRoutedEventArgs e)
    {
      Debug.WriteLine("ChildObj.Tapped occurred");
    }

    private void QueryMap(Point offset)
    {
      foreach (var obj in MyMap.FindMapElementsAtOffset(offset))
      {
        Debug.WriteLine(obj.GetType());
      };
    }

    private void MyMap_OnMapTapped(MapControl sender, MapInputEventArgs args)
    {
      Debug.WriteLine("MyMap.MapTapped occurred");
      QueryMap(args.Position);
    }

    private void MyMap_OnTapped(object sender, TappedRoutedEventArgs e)
    {
      Debug.WriteLine("MayMap.Tapped occurred");
      QueryMap(e.GetPosition(MyMap));
    }
  }
}
